---
title: Update account filters
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Cloud Cost Management
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Update account filters{% #update-account-filters %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                       |
| ----------------- | ---------------------------------------------------------------------------------- |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/cost/account_filters/{cloud_account_id} |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/cost/account_filters/{cloud_account_id} |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/cost/account_filters/{cloud_account_id}      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/cost/account_filters/{cloud_account_id}      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/cost/account_filters/{cloud_account_id}  |
| uk1.datadoghq.com | PATCH https://api.uk1.datadoghq.com/api/v2/cost/account_filters/{cloud_account_id} |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/cost/account_filters/{cloud_account_id}     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/cost/account_filters/{cloud_account_id} |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/cost/account_filters/{cloud_account_id} |

### Overview

Update the account filters for a cloud account (AWS CUR 1.0/2.0, OCI, and other clouds). This endpoint requires the `cloud_cost_management_write` permission.

OAuth apps require the `cloud_cost_management_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#cloud-cost-management) to access this endpoint.



### Arguments

#### Path Parameters

| Name                               | Type    | Description       |
| ---------------------------------- | ------- | ----------------- |
| cloud_account_id [*required*] | integer | Cloud Account id. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field    | Field                             | Type     | Description                                                                                                             |
| --------------- | --------------------------------- | -------- | ----------------------------------------------------------------------------------------------------------------------- |
|                 | data [*required*]            | object   | Account filters patch data.                                                                                             |
| data            | attributes [*required*]      | object   | Attributes for an account filters patch request.                                                                        |
| attributes      | account_filters [*required*] | object   | The account filtering configuration.                                                                                    |
| account_filters | excluded_accounts                 | [string] | The AWS account IDs to be excluded from your billing dataset. This field is used when `include_new_accounts` is `true`. |
| account_filters | include_new_accounts              | boolean  | Whether or not to automatically include new member accounts by default in your billing dataset.                         |
| account_filters | included_accounts                 | [string] | The AWS account IDs to be included in your billing dataset. This field is used when `include_new_accounts` is `false`.  |
| data            | type [*required*]            | enum     | Type of account filters patch request. Allowed enum values: `account_filters_patch_request`                             |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "account_filters": {
        "excluded_accounts": [
          "123456789123",
          "123456789143"
        ],
        "include_new_accounts": true,
        "included_accounts": [
          "123456789123",
          "123456789143"
        ]
      }
    },
    "type": "account_filters_patch_request"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing the account filters for a cloud account.

| Parent field    | Field                        | Type     | Description                                                                                                             |
| --------------- | ---------------------------- | -------- | ----------------------------------------------------------------------------------------------------------------------- |
|                 | data                         | object   | The account filters for a cloud account.                                                                                |
| data            | attributes [*required*] | object   | Attributes for the account filters of a cloud account.                                                                  |
| attributes      | account_filters              | object   | The account filtering configuration.                                                                                    |
| account_filters | excluded_accounts            | [string] | The AWS account IDs to be excluded from your billing dataset. This field is used when `include_new_accounts` is `true`. |
| account_filters | include_new_accounts         | boolean  | Whether or not to automatically include new member accounts by default in your billing dataset.                         |
| account_filters | included_accounts            | [string] | The AWS account IDs to be included in your billing dataset. This field is used when `include_new_accounts` is `false`.  |
| attributes      | account_id                   | string   | The cloud account ID.                                                                                                   |
| attributes      | cloud                        | string   | The cloud provider of the account, for example `aws`, `aws_cur2`, or `oci`.                                             |
| data            | id                           | string   | The ID of the cloud account.                                                                                            |
| data            | type [*required*]       | enum     | Type of account filters. Allowed enum values: `account_filters`                                                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "account_filters": {
        "excluded_accounts": [
          "123456789123",
          "123456789143"
        ],
        "include_new_accounts": true,
        "included_accounts": [
          "123456789123",
          "123456789143"
        ]
      },
      "account_id": "123456789123",
      "cloud": "aws_cur2"
    },
    "id": "123456789123",
    "type": "account_filters"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## Exclude new accounts and include specific accounts
# 
 \# Path parameters export cloud_account_id="CHANGE_ME" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/cost/account_filters/${cloud_account_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "account_filters": {
        "include_new_accounts": false,
        "included_accounts": [
          "123456789123",
          "123456789143"
        ]
      }
    },
    "type": "account_filters_patch_request"
  }
}
EOF \## Include new accounts and exclude specific accounts
# 
 \# Path parameters export cloud_account_id="CHANGE_ME" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/cost/account_filters/${cloud_account_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "account_filters": {
        "excluded_accounts": [
          "123456789123",
          "123456789143"
        ],
        "include_new_accounts": true
      }
    },
    "type": "account_filters_patch_request"
  }
}
EOF 
                
##### 

```python
"""
Update account filters returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.cloud_cost_management_api import CloudCostManagementApi
from datadog_api_client.v2.model.account_filtering_config import AccountFilteringConfig
from datadog_api_client.v2.model.account_filters_patch_data import AccountFiltersPatchData
from datadog_api_client.v2.model.account_filters_patch_request import AccountFiltersPatchRequest
from datadog_api_client.v2.model.account_filters_patch_request_attributes import AccountFiltersPatchRequestAttributes
from datadog_api_client.v2.model.account_filters_patch_request_type import AccountFiltersPatchRequestType

body = AccountFiltersPatchRequest(
    data=AccountFiltersPatchData(
        attributes=AccountFiltersPatchRequestAttributes(
            account_filters=AccountFilteringConfig(
                excluded_accounts=[
                    "123456789123",
                    "123456789143",
                ],
                include_new_accounts=True,
                included_accounts=[
                    "123456789123",
                    "123456789143",
                ],
            ),
        ),
        type=AccountFiltersPatchRequestType.ACCOUNT_FILTERS_PATCH_REQUEST,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = CloudCostManagementApi(api_client)
    response = api_instance.update_cost_account_filters(cloud_account_id=9223372036854775807, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update account filters returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::CloudCostManagementAPI.new

body = DatadogAPIClient::V2::AccountFiltersPatchRequest.new({
  data: DatadogAPIClient::V2::AccountFiltersPatchData.new({
    attributes: DatadogAPIClient::V2::AccountFiltersPatchRequestAttributes.new({
      account_filters: DatadogAPIClient::V2::AccountFilteringConfig.new({
        excluded_accounts: [
          "123456789123",
          "123456789143",
        ],
        include_new_accounts: true,
        included_accounts: [
          "123456789123",
          "123456789143",
        ],
      }),
    }),
    type: DatadogAPIClient::V2::AccountFiltersPatchRequestType::ACCOUNT_FILTERS_PATCH_REQUEST,
  }),
})
p api_instance.update_cost_account_filters(9223372036854775807, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Update account filters returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AccountFiltersPatchRequest{
		Data: datadogV2.AccountFiltersPatchData{
			Attributes: datadogV2.AccountFiltersPatchRequestAttributes{
				AccountFilters: datadogV2.AccountFilteringConfig{
					ExcludedAccounts: []string{
						"123456789123",
						"123456789143",
					},
					IncludeNewAccounts: *datadog.NewNullableBool(datadog.PtrBool(true)),
					IncludedAccounts: []string{
						"123456789123",
						"123456789143",
					},
				},
			},
			Type: datadogV2.ACCOUNTFILTERSPATCHREQUESTTYPE_ACCOUNT_FILTERS_PATCH_REQUEST,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCloudCostManagementApi(apiClient)
	resp, r, err := api.UpdateCostAccountFilters(ctx, 9223372036854775807, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CloudCostManagementApi.UpdateCostAccountFilters`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CloudCostManagementApi.UpdateCostAccountFilters`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update account filters returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CloudCostManagementApi;
import com.datadog.api.client.v2.model.AccountFilteringConfig;
import com.datadog.api.client.v2.model.AccountFiltersPatchData;
import com.datadog.api.client.v2.model.AccountFiltersPatchRequest;
import com.datadog.api.client.v2.model.AccountFiltersPatchRequestAttributes;
import com.datadog.api.client.v2.model.AccountFiltersPatchRequestType;
import com.datadog.api.client.v2.model.AccountFiltersResponse;
import java.util.Arrays;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    CloudCostManagementApi apiInstance = new CloudCostManagementApi(defaultClient);

    AccountFiltersPatchRequest body =
        new AccountFiltersPatchRequest()
            .data(
                new AccountFiltersPatchData()
                    .attributes(
                        new AccountFiltersPatchRequestAttributes()
                            .accountFilters(
                                new AccountFilteringConfig()
                                    .excludedAccounts(Arrays.asList("123456789123", "123456789143"))
                                    .includeNewAccounts(true)
                                    .includedAccounts(
                                        Arrays.asList("123456789123", "123456789143"))))
                    .type(AccountFiltersPatchRequestType.ACCOUNT_FILTERS_PATCH_REQUEST));

    try {
      AccountFiltersResponse result =
          apiInstance.updateCostAccountFilters(9223372036854775807L, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CloudCostManagementApi#updateCostAccountFilters");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Update account filters returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_cloud_cost_management::CloudCostManagementAPI;
use datadog_api_client::datadogV2::model::AccountFilteringConfig;
use datadog_api_client::datadogV2::model::AccountFiltersPatchData;
use datadog_api_client::datadogV2::model::AccountFiltersPatchRequest;
use datadog_api_client::datadogV2::model::AccountFiltersPatchRequestAttributes;
use datadog_api_client::datadogV2::model::AccountFiltersPatchRequestType;

#[tokio::main]
async fn main() {
    let body = AccountFiltersPatchRequest::new(AccountFiltersPatchData::new(
        AccountFiltersPatchRequestAttributes::new(
            AccountFilteringConfig::new()
                .excluded_accounts(vec!["123456789123".to_string(), "123456789143".to_string()])
                .include_new_accounts(Some(true))
                .included_accounts(vec!["123456789123".to_string(), "123456789143".to_string()]),
        ),
        AccountFiltersPatchRequestType::ACCOUNT_FILTERS_PATCH_REQUEST,
    ));
    let configuration = datadog::Configuration::new();
    let api = CloudCostManagementAPI::with_config(configuration);
    let resp = api
        .update_cost_account_filters(9223372036854775807, body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update account filters returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.CloudCostManagementApi(configuration);

const params: v2.CloudCostManagementApiUpdateCostAccountFiltersRequest = {
  body: {
    data: {
      attributes: {
        accountFilters: {
          excludedAccounts: ["123456789123", "123456789143"],
          includeNewAccounts: true,
          includedAccounts: ["123456789123", "123456789143"],
        },
      },
      type: "account_filters_patch_request",
    },
  },
  cloudAccountId: 9223372036854775807,
};

apiInstance
  .updateCostAccountFilters(params)
  .then((data: v2.AccountFiltersResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
